<?php
class ModelSaleSaleOrder extends Model {
	
	//get open tables
	public function getTakenTables(){
		$query = $this->db->query("SELECT table_id, table_order_id FROM " . DB_PREFIX . "table_orders where status = 'open'");
	return $query->rows;
	
		}
		
	
	//get initial kot data for table order
	public function getOpenKots(){
	$query = $this->db->query("SELECT tk.table_order_id, tk.kot_id, k.time FROM oc_table_orders_to_kot tk LEFT JOIN oc_kot k ON (tk.kot_id = k.kot_id) where k.status = 'open'");
	    return $query->rows;
	
		}


	//get initial kot data for takeaway order
	public function getOpenTakeawayKots(){
		$query = $this->db->query("SELECT tk.takeaway_order_id, tk.kot_id, k.time FROM oc_takeaway_to_kot tk LEFT JOIN oc_kot k ON (tk.kot_id = k.kot_id) where k.status = 'open'");
	    return $query->rows;
	
		}

	
	//kot products
	public function getKotProducts($kot_ids){
		$query = $this->db->query("SELECT  kot_id, product_id, price, name, quantity, category_id FROM " . DB_PREFIX . "kot_to_product where kot_id IN  (".$kot_ids.")");
	    return $query->rows;
	
		}
	
	//get recent kot data
	public function getLastKot(){
	 	$query = $this->db->query("SELECT table_order_id, k.kot_id, time FROM " . DB_PREFIX . "kot k LEFT JOIN oc_table_orders_to_kot tk ON (k.kot_id = tk.kot_id) where status = 'open' ORDER BY k.kot_id DESC LIMIT 1");
	    return $query->rows;
		
		}
	
	//get customers
	public function getSaleCustomer(){
	$sql = "SELECT customer_id, firstname, email, telephone from oc_customer";
	
	$query = $this->db->query($sql);
	return $query->rows;
	
	
	}

	
	//get recent kot data
	public function getLastKotTakeaway(){
	 	$query = $this->db->query("SELECT takeaway_order_id, k.kot_id, time FROM " . DB_PREFIX . "kot k LEFT JOIN oc_takeaway_to_kot tk ON (k.kot_id = tk.kot_id) where status = 'open' ORDER BY k.kot_id DESC LIMIT 1");
	    return $query->rows;
		
		}
	
	//getPaymentMethods
	public function getPaymentMethods(){
		$query = $this->db->query("SELECT * from oc_payment_methods");
	    return $query->rows;
		
		}
	
	//get waiter
	public function getWaiters(){
		$query = $this->db->query("SELECT * from oc_waiter_list");
	    return $query->rows;
		
		}
	
	//get waiter
	public function getOrderSources(){
		$query = $this->db->query("SELECT * from oc_order_source_list");
	    return $query->rows;
		
		}
	
	
	public function getLastKotProducts($kot_ids){
		$query = $this->db->query("SELECT  kot_id, product_id, price, name, quantity, category_id FROM " . DB_PREFIX . "kot_to_product where kot_id = '".$kot_ids."'");
	    return $query->rows;
	
		}
		
	
	
		
	//save table bill
	public function save_table_bill($data){

$query = $this->db->query("INSERT into oc_table_bills SET created_by = '".$this->db->escape($data['created_by'])."', date = '".$this->db->escape($data['date'])."', time = '".$this->db->escape($data['time'])."', grand_total = '".$this->db->escape($data['grand_total'])."', service_charges = '".$this->db->escape($data['service_charges'])."', discount = '".$this->db->escape($data['discount'])."', payment_method = '".$this->db->escape($data['payment_method'])."', served_by = '".$this->db->escape($data['served_by'])."', erase_flag = '".$this->db->escape($data['erase_flag'])."',  table_order_id = '".$this->db->escape($data['table_order_id'])."', customer_id = '".$this->db->escape($data['customer_id'])."', table_id = '".$this->db->escape($data['created_by'])."'");	
		
		$table_bill_id = $this->db->getLastId();
   
   for($i=0; $i<sizeof($data['product_id']); $i++){
	 $query = $this->db->query("INSERT into oc_table_bills_to_product SET table_bill_id = '".$this->db->escape($table_bill_id)."', product_id = '".$this->db->escape($data['product_id'][$i])."', name ='".$this->db->escape($data['product_name'][$i])."', price ='".$this->db->escape($data['product_price'][$i])."', quantity ='".$this->db->escape($data['product_qty'][$i])."'");
	   }
	   
 //close open tables
 $query = $this->db->query("UPDATE oc_table_orders SET status = 'close', clear_time = '".$this->db->escape($data['time'])."' where table_order_id = '".$this->db->escape($data['table_order_id'])."'");
	
 //close open kots
 $query = $this->db->query("UPDATE oc_kot ok left join oc_table_orders_to_kot tok ON (ok.kot_id = tok.kot_id) SET status = 'close' where tok.table_order_id = '".$this->db->escape($data['table_order_id'])."'");
		}
		
			
	
	
	//takeaway bill
	
	public function save_takeaway_bill($data){

$query = $this->db->query("INSERT into oc_takeaway_bills SET created_by = '".$this->db->escape($data['created_by'])."', date = '".$this->db->escape($data['date'])."', time = '".$this->db->escape($data['time'])."', grand_total = '".$this->db->escape($data['grand_total'])."', service_charges = '".$this->db->escape($data['service_charges'])."', discount = '".$this->db->escape($data['discount'])."', payment_method = '".$this->db->escape($data['payment_method'])."', served_by = '".$this->db->escape($data['served_by'])."', takeaway_order_id ='".$this->db->escape($data['takeaway_order_id'])."', erase_flag = '".$this->db->escape($data['erase_flag'])."', customer_id = '".$this->db->escape($data['customer_id'])."'");	
		
		$takeaway_bill_id = $this->db->getLastId();
   
   for($i=0; $i<sizeof($data['product_id']); $i++){
	 $query = $this->db->query("INSERT into oc_takeaway_to_products SET takeaway_bill_id = '".$this->db->escape($takeaway_bill_id)."', product_id = '".$this->db->escape($data['product_id'][$i])."', name ='".$this->db->escape($data['product_name'][$i])."', price ='".$this->db->escape($data['product_price'][$i])."', quantity ='".$this->db->escape($data['product_qty'][$i])."'");
	   }
	   
 //close open tables
$query = $this->db->query("UPDATE oc_takeaway_orders SET status = 'close' where takeaway_order_id = '".$data['takeaway_order_id']."'");
	
 //close open kots
 $query = $this->db->query("UPDATE oc_kot ok left join oc_takeaway_to_kot tok ON (ok.kot_id = tok.kot_id) SET status = 'close' where tok.takeaway_order_id = '".$data['takeaway_order_id']."'");
		}
		
	
	
	
	public function getCategories($parent_id = 0) {
		$query = $this->db->query("SELECT * FROM " . DB_PREFIX . "category c LEFT JOIN " . DB_PREFIX . "category_description cd ON (c.category_id = cd.category_id) LEFT JOIN " . DB_PREFIX . "category_to_store c2s ON (c.category_id = c2s.category_id) WHERE c.parent_id = '" . (int)$parent_id . "' AND cd.language_id = '" . (int)$this->config->get('config_language_id') . "' AND c2s.store_id = '" . (int)$this->config->get('config_store_id') . "'  AND c.status = '1' ORDER BY c.sort_order, LCASE(cd.name)");

		return $query->rows;
	}

public function getProducts(){
	$query = $this->db->query("SELECT p.product_id, quantity, price, tax_class_id, subtract, name, category_id from oc_product p LEFT JOIN oc_product_description pd ON (p.product_id = pd.product_id) LEFT JOIN oc_product_to_category p2c ON (p.product_id = p2c.product_id)");
		return $query->rows;

	}
	
public function insertTableOrder($data){
	
	$query = $this->db->query("INSERT into oc_table_orders SET table_id = '".$this->db->escape($data['table_id'])."', open_time = '".$this->db->escape($data['open_time'])."', date ='".$this->db->escape($data['date'])."', open_by ='".$this->db->escape($data['open_by'])."', status ='".$this->db->escape($data['status'])."'");
	
	return $this->db->getLastId();
	
	}	


public function insertTakeawayOrder($data){
	
	$query = $this->db->query("INSERT into oc_takeaway_orders SET customer_id = '".$this->db->escape($data['customer_id'])."', order_open_time = '".$this->db->escape($data['order_open_time'])."', date ='".$this->db->escape($data['date'])."', open_by ='".$this->db->escape($data['open_by'])."', status ='".$this->db->escape($data['status'])."'");
	
	return $this->db->getLastId();
	
	}	



public function insertKot($data){
	
	$query = $this->db->query("INSERT into oc_kot SET total_amount = '".$this->db->escape($data['total'])."', time = '".$this->db->escape($data['time'])."', date ='".$this->db->escape($data['date'])."', created_by ='".$this->db->escape($data['created_by'])."', status ='".$this->db->escape($data['status'])."'");
	
   $kot_id = $this->db->getLastId();
   
   for($i=0; $i<sizeof($data['product_id']); $i++){
	 $query = $this->db->query("INSERT into oc_kot_to_product SET kot_id = '".$this->db->escape($kot_id)."', product_id = '".$this->db->escape($data['product_id'][$i])."', name ='".$this->db->escape($data['product_name'][$i])."', price ='".$this->db->escape($data['product_price'][$i])."', quantity ='".$this->db->escape($data['product_qty'][$i])."', category_id ='".$this->db->escape($data['category_id'][$i])."'");
	   }
return $kot_id;  

	}	

public function mapTableToKot($table_order_id,$kot_id){
	   $query = $this->db->query("INSERT into oc_table_orders_to_kot SET table_order_id = '".$this->db->escape($table_order_id)."', kot_id = '".$this->db->escape($kot_id)."'");
	 }


public function mapTakeawayToKot($takeaway_order_id ,$kot_id){
	 $query = $this->db->query("INSERT into oc_takeaway_to_kot SET takeaway_order_id = '".$this->db->escape($takeaway_order_id)."', kot_id = '".$this->db->escape($kot_id)."'");
	 
	}


public function addCustomer($customer_name, $customer_email, $customer_phone){
	$salt = token(9);
	$password ='12345';
	
	   $query = $this->db->query("INSERT into oc_customer SET customer_group_id = '1', store_id = '0', language_id = '1', firstname = '".$this->db->escape($customer_name)."', email = '".$this->db->escape($customer_email)."', telephone = '".$this->db->escape($customer_phone)."', password = '".$this->db->escape(sha1($salt . sha1($salt . sha1($password))))."', salt = '" . $this->db->escape($salt) . "'");
	   $customer_id = $this->db->getLastId();
	return $customer_id;
	
	
	}


	}

?>